///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Main Zonerings control window                      //
//                             John Biddiscombe                             //
//                           j.biddiscombe@rl.ac.uk                          //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////
unit Form_Settings;

interface

uses
  { Borland }
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
	StdCtrls, ExtCtrls, Buttons, Dialogs, ComCtrls,
  { Downloaded }
  BorBtns,
  { Mine }
	PalUnit, Thinkbox, Screen_Utils, Str_Util;

type
  TSettings_Form = class(TForm)
    Panel_00: TPanel;
    Panel_01: TPanel;
    Panel_02: TPanel;
    Panel_10: TPanel;
    Panel_11: TPanel;
    Panel_12: TPanel;
    Panel_13: TPanel;
    Panel_20: TPanel;
    Panel_21: TPanel;
    Panel_22: TPanel;
		Panel_23: TPanel;
		Pal_panel: TPanel;

		L_maxZ: TLabel;
		L_vanish: TLabel;
		L_persp: TLabel;
		L_mag: TLabel;
		L_aspect: TLabel;
		L_ampy: TLabel;
		L_freqx: TLabel;
		L_freqy: TLabel;
		L_ampx: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    L_maxsp: TLabel;
    L_minsp: TLabel;
    L_rcrfreq: TLabel;
    L_prob_dens: TLabel;
    d1: TLabel;
    Label8: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label5: TLabel;
    Label6: TLabel;
		Label31: TLabel;
    Label32: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label25: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label23: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label34: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;

// general control
    max_polygons       : TScrollBar;
    vanishing          : TScrollBar;
    perspective        : TScrollBar;
    magnification      : TScrollBar;
    rub_out            : TBorCheck;
		in_out             : TBorCheck;
    hide_cursor        : TBorCheck;
    Screensaver        : TBorCheck;
// Aspect control
    aspect_sync        : TBorCheck;
    aspect_a_x         : TScrollBar;
    aspect_a_y         : TScrollBar;
    aspect_f_x         : TScrollBar;
    aspect_f_y         : TScrollBar;
// rotation control
    no_rotation        : TBorRadio;
    sin_rotation       : TBorRadio;
    ran_rotation       : TBorRadio;
    ampl               : TScrollBar;
    precess            : TScrollBar;
    freq               : TScrollBar;
    max_rot_speed      : TScrollBar;
    min_rot_speed      : TScrollBar;
    rot_ran_per        : TBorRadio;
    rot_ran_ran        : TBorRadio;
    rot_ran_freq       : TScrollBar;
// shape control
    shape_per          : TBorRadio;
		shape_ran          : TBorRadio;
    shape_freq         : TScrollBar;
// motion control
    no_motion          : TBorRadio;
    mouse_motion       : TBorRadio;
    ran_fluid_motion   : TBorRadio;
    ran_jump_motion    : TBorRadio;
    par_motion         : TBorRadio;
    mot_b_damping      : TScrollBar;
    mot_ran_freq       : TScrollBar;
    ran_gaussian       : TBorRadio;
    ran_uniform        : TBorRadio;
// density control
    density1           : TScrollBar;
    density2           : TScrollBar;
    density3           : TScrollBar;
    density4           : TScrollBar;
		density5           : TScrollBar;
    density6           : TScrollBar;
    density7           : TScrollBar;
    density8           : TScrollBar;
    density9           : TScrollBar;
    density10          : TScrollBar;
// draw style
    draw_solid         : TBorRadio;
    draw_vertices      : TBorRadio;
// palette control
    palette_inc        : TScrollBar;
    colour_step        : TScrollBar;
    palette_list       : TListBox;

		PDF_zero           : TButton;
		PDF_max            : TButton;
		rot_zero           : TButton;
		ZeroPalBtn         : TButton;
		Set_speed          : TButton;
		ZeroAspBtn         : TButton;

		Load_btn           : TButton;
		Save_btn           : TButton;
		Options_Btn        : TButton;
		About_btn          : TButton;
		Kill_btn           : TButton;
		f_speed: TLabel;
		Label27: TLabel;
		Label35: TLabel;
		Label26: TLabel;
		Label36: TLabel;
		designed_speed: TLabel;
		fix_speed: TBorCheck;
		Label33: TLabel;
		pause_freeze: TBorRadio;
		pause_continue: TBorRadio;
		speed_scroll: TScrollBar;
    lock_xy_motion: TBorCheck;
    Bevel5: TBevel;
		Bevel6: TBevel;
    Bevel7: TBevel;
    Bevel8: TBevel;
    Button1: TButton;
    Button2: TButton;
    lock_xy_aspect: TBorCheck;
    Help_btn: TButton;
    UsePalette: TBorRadio;
    RGBwalk: TBorRadio;
    mot_par_a: TScrollBar;
    mot_par_d: TScrollBar;
    mot_par_b: TScrollBar;
    mot_par_e: TScrollBar;
    mot_par_c: TScrollBar;
    mot_par_f: TScrollBar;
    Z_icon: TImage;
    btn_r: TButton;
    btn_f: TButton;
    Label1: TLabel;
    Label22: TLabel;
    control_points: TScrollBar;
    Label24: TLabel;
    eccentricity: TScrollBar;
    Label37: TLabel;
    Gamma: TScrollBar;
    Label38: TLabel;

    procedure Kill_btnClick(Sender:TObject);
    procedure OK_btnClick(Sender:TObject);
		procedure Can_btnClick(Sender:TObject);
    procedure Load_btnClick(Sender:TObject);
    procedure FormCreate(Sender:TObject);
    procedure max_rot_speedScroll(Sender:TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure FormShow(Sender:TObject);
    procedure PDF_zeroClick(Sender:TObject);
    procedure fix_speedClick(Sender:TObject);
    procedure Set_speedClick(Sender:TObject);
    procedure speed_scrollChange(Sender:TObject);
		procedure Save_btnClick(Sender:TObject);
    procedure About_btnClick(Sender:TObject);
    procedure Options_BtnClick(Sender:TObject);
    procedure rot_zeroClick(Sender:TObject);
    procedure ZeroPalBtnClick(Sender:TObject);
    procedure FormKeyDown(Sender:TObject; var Key: Word;
      Shift: TShiftState);
    procedure ZeroAspBtnClick(Sender:TObject);
    procedure scrollbar_lock(Sender:TObject);
    procedure UsePaletteClick(Sender:TObject);
    procedure Help_btnClick(Sender:TObject);
    procedure btn_fClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    just_loaded : boolean;
    procedure WriteText(var dest:TStringList;   aname:string);
    procedure ReadText (source:TStringList);
    function  GetPalette : hPalette; override;
  end;

var
  Settings_Form : TSettings_Form;

implementation

{$R *.DFM}

{$IFNDEF SCREENSAVER }
uses
  Zone_Rings, Zone_settings, Form_Main, Form_Load_Save, Form_About, Form_Options;
{$ENDIF }

{ ----------------------------------------------------------------------- }
{                           Load/Save settings                            }
{ ----------------------------------------------------------------------- }
procedure TSettings_Form.WriteText(var dest:TStringList; aname:string);
var lp1 : integer;
    TC  : TComponent;
begin
  if dest=nil then dest:=TStringList.Create;
  dest.Clear;
  dest.Add(aname);
  for lp1:=0 to ComponentCount-1 do begin
    TC := Components[lp1];
    if TC is TScrollBar then with TScrollBar(TC) do
      dest.Add(Format('%20s',[TC.name])+#9+IntToStr(min)+#9+IntToStr(max)+#9+IntToStr(position))
    else if TC is TBorRadio then
			dest.Add(Format('%20s',[TC.name])+#9+BoolToStr(TBorRadio(TC).checked))
    else if TC is TBorCheck then
      dest.Add(Format('%20s',[TC.name])+#9+BoolToStr(TBorCheck(TC).checked))
    else if TC is TListBox then with TListBox(TC) do if ItemIndex<>-1 then 
      dest.Add(Format('%20s',[TC.name])+#9+Items[ItemIndex])
  end;
end;

procedure TSettings_Form.ReadText(source:TStringList);
var lp1   : integer;
    TC    : TComponent;
    alist : TStringlist;
begin
	// as we add new options to zonerings, some of the old files don't have
	// entries for some features... so force them to be set to a default
    fix_speed.checked			:= false;
	lock_xy_aspect.Checked		:= false;
	lock_xy_motion.Checked		:= false;
	UsePalette.Checked				:= true;
	control_points.position		:= 3;
	eccentricity.position			:= 2;
	Gamma.position						:= 1;

	// now read the ones that are defined
	alist := TStringList.Create;
  for lp1:=1 to source.count-1 do begin
    alist := BreakString(source[lp1],alist);
    TC := findComponent(alist[0]);
    if TC is TScrollBar then with TScrollBar(TC) do begin
      min      := StrToInt(alist[1]);
      max      := StrToInt(alist[2]);
      position := StrToInt(alist[3]);
    end
    else if TC is TBorRadio then
			TBorRadio(TC).checked := alist[1]='TRUE'
    else if TC is TBorCheck then
      TBorCheck(TC).checked := alist[1]='TRUE'
		else if TC is TListBox then with TListBox(TC) do
      ItemIndex := Items.IndexOf(UpperCase(alist[1]));
	end;
end;
{ ----------------------------------------------------------------------- }
{                             Event handlers                              }
{ ----------------------------------------------------------------------- }
procedure TSettings_Form.FormCreate(Sender:TObject);
begin
  palette_list.Items.Clear;
	find_all_palettes(TStringList(palette_list.Items));
end;

procedure TSettings_Form.FormShow(Sender:TObject);
begin
{$IFNDEF SCREENSAVER }
	ScreenCenterWindow(Handle);
  just_loaded := false;
{$ENDIF }
end;

procedure TSettings_Form.Kill_btnClick(Sender:TObject);
begin
{$IFNDEF SCREENSAVER }
	LoadSave_Form.Close_file; // do it now before main window closes (looks nicer)
	Zonewindow.ready := false;
{$ENDIF }
	Application.Mainform.close;
end;

procedure TSettings_Form.OK_btnClick(Sender:TObject);
begin
	ModalResult := mrOK;
end;

procedure TSettings_Form.Can_btnClick(Sender:TObject);
begin
	ModalResult := mrCancel;
end;

procedure TSettings_Form.Load_btnClick(Sender:TObject);
begin
{$IFNDEF SCREENSAVER }
	if (Zonewindow.Zone_instance<>nil) then Zonewindow.Zone_instance.Blank_screen;
	if LoadSave_Form.Load_setting=mrOK then just_loaded := true
{$ENDIF }
end;

procedure TSettings_Form.Save_btnClick(Sender:TObject);
begin
{$IFNDEF SCREENSAVER }
	if (Zonewindow.Zone_instance<>nil) then Zonewindow.Zone_instance.Blank_screen;
	LoadSave_Form.Save_setting;
{$ENDIF }
end;

procedure TSettings_Form.About_btnClick(Sender:TObject);
var i	: integer;
		p	: string;
begin
{$IFNDEF SCREENSAVER }
	with Zonewindow do begin
		i := palette_list.ItemIndex;
		if i>=0 then p := palette_list.Items[i] else p:='';
		if (Zone_instance<>nil) then Zone_instance.Blank_screen;
		if About_Form=nil then About_Form :=
			TAbout_Form.Create(Application);
		if (Zone_instance<>nil) then
			About_Form.Setup(ZOptions.Zone_Directory,Global_colour_value)
		else
			About_Form.Setup(ZOptions.Zone_Directory,0);
		About_Form.ShowModal;
		// just in case user created a new palette
		palette_list.Items.Clear;
		find_all_palettes(TStringList(palette_list.Items));
		palette_list.ItemIndex := palette_list.Items.IndexOf(p);
	end;
{$ENDIF }
end;

procedure TSettings_Form.Options_BtnClick(Sender:TObject);
begin
{$IFNDEF SCREENSAVER }
	if Options_Form=nil then Options_Form := TOptions_Form.Create(Application);
	Options_Form.Showmodal;
{$ENDIF }
end;

function TSettings_Form.GetPalette : hPalette;
begin
	result := inherited GetPalette;
end;

procedure TSettings_Form.fix_speedClick(Sender:TObject);
begin
  if fix_speed.checked then begin
		speed_scroll.Enabled := false;
		Set_speed.Enabled    := false;
	end else begin
		speed_scroll.Enabled := true;
		Set_speed.Enabled    := true;
  end;
end;

procedure TSettings_Form.Set_speedClick(Sender:TObject);
begin
  designed_speed.Caption := f_speed.Caption;
  speed_scroll.position  := StrToInt(f_speed.Caption);
end;

procedure TSettings_Form.speed_scrollChange(Sender:TObject);
begin
	designed_speed.Caption := IntToStr(speed_scroll.Position);
end;

procedure TSettings_Form.max_rot_speedScroll(Sender:TObject;
	ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
	if sender = max_rot_speed then if ScrollPos<min_rot_speed.position then
			ScrollPos:=min_rot_speed.position;
	if sender = min_rot_speed then if ScrollPos>max_rot_speed.position then
			ScrollPos:=max_rot_speed.position;
end;

procedure TSettings_Form.PDF_zeroClick(Sender:TObject);
var lp1 : integer;
		scr : TScrollbar;
begin
	for lp1:=1 to 10 do begin // scrollbars are wrong way round !
		scr := TScrollbar(FindComponent('density'+inttostr(lp1)));
		if sender=PDF_zero then scr.position:= scr.max
		else if sender=PDF_max then scr.position:= scr.min;
	end;
end;

procedure TSettings_Form.rot_zeroClick(Sender:TObject);
begin
  ampl.position          := ampl.min;
  freq.position          := 0;
  precess.position       := 0;
  max_rot_speed.position := 0;
  min_rot_speed.position := 0;
end;

procedure TSettings_Form.ZeroPalBtnClick(Sender:TObject);
begin
	palette_inc.position := 0;
	colour_step.position := 0;
	control_points.position := control_points.min;
	eccentricity.position   := eccentricity.min;
end;

procedure TSettings_Form.ZeroAspBtnClick(Sender:TObject);
begin
	aspect_a_x.position := aspect_a_x.max div 2;
	aspect_a_y.position := aspect_a_y.max div 2;
	aspect_f_x.position := 0;
	aspect_f_y.position := 0;
end;

procedure TSettings_Form.Help_btnClick(Sender:TObject);
begin
	Application.HelpContext(0);
end;

procedure TSettings_Form.FormKeyDown(Sender:TObject; var Key:Word; Shift:TShiftState);
begin
	if Key=VK_F1 then Application.HelpContext(0);
end;

procedure TSettings_Form.scrollbar_lock(Sender:TObject);
begin
	if lock_xy_motion.Checked then begin
		if sender = mot_par_a then mot_par_d.position := mot_par_a.position
		else if sender = mot_par_d then mot_par_a.position := mot_par_d.position;
		if sender = mot_par_b then mot_par_e.position := mot_par_b.position
		else if sender = mot_par_e then mot_par_b.position := mot_par_e.position;
		if sender = mot_par_c then mot_par_f.position := mot_par_c.position
		else if sender = mot_par_f then mot_par_c.position := mot_par_f.position;
	end;
	if lock_xy_aspect.Checked then begin
		if sender = aspect_a_x then aspect_a_y.position := aspect_a_x.position
		else if sender = aspect_a_y then aspect_a_x.position := aspect_a_y.position;
		if sender = aspect_f_x then aspect_f_y.position := aspect_f_x.position
		else if sender = aspect_f_y then aspect_f_x.position := aspect_f_y.position;
	end;
end;

procedure TSettings_Form.UsePaletteClick(Sender:TObject);
begin
	Palette_list.enabled := UsePalette.Checked;
end;

procedure TSettings_Form.btn_fClick(Sender: TObject);
begin
	if Sender = btn_f then mot_par_a.position := round(mot_par_a.position / 32)*32
	else                   mot_par_b.position := round(mot_par_b.position / 32)*32
end;

end.

