///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                         Palette management routines                       //
//                             John Biddiscombe                             //
//                           j.biddiscombe@rl.ac.uk                          //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////
unit PalUnit;

interface

// Most of this code is old, it could do with a rewrite.

// Most of my programs use one palette at a time, so I use hPalApp and
// App_Palette a lot. Be careful...

uses
	{ Borland }
	Windows, SysUtils, Classes, Math, Dialogs,
	{ Mine }
	ThinkBox;

type
	palentries   = array[0..255] of TPaletteEntry;
	Ppalentries  = ^palentries;
	palindices   = array[0..255] of word;
	RGBQuads     = array[0..255] of TRGBQUAD;

type
	pMyBitmapInfo  = ^TMyBitmapInfo;
	TMyBitmapInfo  = record
		BMIheader   : TBITMAPINFOHEADER;
		BMIcolors   : palindices;
	end;

type
	TMyLogPalette = record
		palVersion    : Word;
		palNumEntries : Word;
		palEntry      : palentries;
		// Above 3 MUST be kept together
		pal_mycolours : integer;
	end;

// A rather odd object used for nicccce.....palette walking in Zonerings
type
	RGBdouble = record r,g,b : double; end;
	RGBvalues = record r,g,b : integer; end;

	pal_animator = class(TObject)
		num_controls : integer;
		points       : integer;
		pp_edge      : integer;
		ran_factor   : integer;
		gamma				 : double;
		gamma_v      : array[0..255] of integer;
		controls     : array[0..15] of RGBvalues;
		incs         : array[0..15] of RGBvalues;
		RGB_nogamma  : palentries;
		RGB_values   : palentries;
		constructor create(nc,rf:integer; gamma_:double);
		function 		new_random_p : integer;
		function 		new_random_m : integer;
		procedure   update;
		procedure		create_pseudo_gamma_lookups(g:double);
		procedure   pseudo_gamma_correct;
	end;

// C++Builder screws up typedefs - so use int instead of HPen,HPalette
type
	pen_array = array[0..255] of integer;
	pPens     = ^pen_array;

function  Set_Palette_Directory(dir:string) : boolean;
function  create_256_identity_palette_from_file(var pal:TMyLogPalette;var Hpal:integer; filename:shortstring) : boolean;
procedure create_default_236_greyscale_palette(var pal:TMyLogPalette; var Hpal:integer);
procedure default_log_palette(var pal:TMyLogPalette);
procedure create_256_pens_using_paletteindex(var pens:pen_array; style:integer);
procedure dispose_256_pens(pens:pen_array);
procedure LogPal_to_RGBQuad(f,n:word; var logpal:palentries; var RGBQuad:RGBQuads);
procedure find_all_palettes(destlist:TStringList);
function  DirectoryExists(dir:string) : boolean;

// the global variables here are useful.
var
	Palette_Dir   : string;

implementation

function Set_Palette_Directory(dir:string) : boolean;
var fullname  : string;
	F         : TSearchRec;
	i         : integer;
begin
	if dir[length(dir)]='\' then Palette_Dir := dir
	else Palette_Dir := dir + '\';
	if DirectoryExists(Palette_Dir) then begin
		fullname    := palette_dir+'*.pal';
		i           := FindFirst(fullname,faAnyFile,F);
		if (i<>0) then result := false
		else result := true;
		FindClose(F);
	end else result := false;
end;

function create_256_identity_palette_from_file(var pal:TMyLogPalette;var Hpal:integer; filename:shortstring) : boolean;
var screen        : hDC;
		pal_cols      : integer;
		lp1,lp2,c1,c2 : Integer;
		f             : text;
		instr,substr  : shortstring;
		r_g_b         : array[1..3] of integer;
		pal_name      : string;
begin
	result := true;
	if extractfilepath(filename)='' then pal_name := Palette_Dir+filename
	else pal_name:=filename;
	if not fileexists(pal_name) then begin
		result := false;
		exit;
	end;
	assign(f,pal_name); reset(f); readln(f,pal_cols);
	if pal_cols>236 then pal_cols := 236;
	pal.palVersion    := $0300;
	pal.palNumEntries := 256;
	pal.pal_mycolours := pal_cols;

	Screen            := GetDC(0);
	GetSystemPaletteEntries(Screen,0  ,10,pal.palEntry);
	GetSystemPaletteEntries(Screen,246,10,pal.palEntry[246]);
	ReleaseDC(0,Screen);

	for lp1:=0 to pal_cols-1 do begin
		readln(f,instr); c1:=1;
		for lp2:=1 to 3 do begin
			c2:=1;
			while (instr[c1]=' ') do inc(c1);
			while (instr[c1]<>' ') and (c1<=length(instr)) do begin
				substr[c2]:=instr[c1];
				inc(c1); inc(c2);
			end;
			substr[0]:=chr(c2-1);
			val(substr,r_g_b[lp2],c2);
		end;
		pal.palEntry[10+lp1].peFlags := PC_RESERVED;
		pal.palEntry[10+lp1].peRed   := r_g_b[1];
		pal.palEntry[10+lp1].peGreen := r_g_b[2];
		pal.palEntry[10+lp1].peBlue  := r_g_b[3];
	end;
	if (Hpal<>0) then if (not DeleteObject(Hpal)) then Thinking_error('Palette not deleted #0');
	Hpal := CreatePalette(PLogPalette(@pal)^);
	close(f);
end;

procedure create_default_236_greyscale_palette(var pal:TMyLogPalette; var Hpal:integer);
begin
	default_log_palette(pal);
	if (Hpal<>0) then DeleteObject(Hpal);
	Hpal := CreatePalette(PLogPalette(@pal)^);
end;

procedure default_log_palette(var pal:TMyLogPalette);
var screen : hDC;
		lp1,c  : Integer;
begin
	pal.palVersion    := $0300;
	pal.palNumEntries := 256;
	pal.pal_mycolours := 236;

	Screen            := GetDC(0);
	GetSystemPaletteEntries(Screen,0  ,10,pal.palEntry);
	GetSystemPaletteEntries(Screen,246,10,pal.palEntry[246]);
	ReleaseDC(0,Screen);
	// setup with greyscale by default
	for lp1:=0 to pal.pal_mycolours-1 do begin
		c := round(lp1*(255/(pal.pal_mycolours-1)));
		pal.palEntry[10+lp1].peFlags := PC_RESERVED;
		pal.palEntry[10+lp1].peRed   := c;
		pal.palEntry[10+lp1].peGreen := c;
		pal.palEntry[10+lp1].peBlue  := c;
	end;
end;

// Create pens from palette. Because we use PaletteIndex to create the pens,
// we can still use them after the palette changes
procedure create_256_pens_using_paletteindex(var pens:pen_array; style:integer);
var lp1 : integer;
		tp	:	TLogPen;
begin
	for lp1:=0 to 255 do begin
		tp.lopnStyle := style;
		pinteger(@tp.lopnWidth)^ := 1;
		tp.lopnColor := paletteindex(lp1);
		pens[lp1] := CreatePenIndirect(tp);
		if pens[lp1]=0 then begin
			messageBox(0,'Caution : Error creating pens'#13'Windows may be low on resources !!!',
			'GDI cockup',mb_ok);
			postquitmessage(0); exit;
		end;
	end;
end;

procedure dispose_256_pens(pens:pen_array);
var lp1 : integer;
begin
	for lp1:=0 to 255 do DeleteObject(pens[lp1]);
end;

procedure LogPal_to_RGBQuad(f,n:word; var logpal:palentries; var RGBQuad:RGBQuads);
var lp1 : integer;
begin
	for lp1:=f to (f+n-1) do begin
		RGBQuad[lp1].rgbRed      := logpal[lp1].peRed;
		RGBQuad[lp1].rgbGreen    := logpal[lp1].peGreen;
		RGBQuad[lp1].rgbBlue     := logpal[lp1].peBlue;
		RGBQuad[lp1].rgbReserved := logpal[lp1].peFlags;
	end;
end;

procedure find_all_palettes(destlist:TStringList);
var fullname  : string;
	F         : TSearchRec;
	i         : integer;
begin // fills a TStringlist with palettes - useful for listboxes
  fullname:=palette_dir+'*.pal';
  i := FindFirst(fullname,faAnyFile,F);
  if i<>0 then exit;
  while i=0 do begin
		if (F.Attr and faDirectory)<>0 then begin end
		else begin
			destlist.Add(F.name);
		end;
		i := FindNext(F);
  end;
  FindClose(F);
end;

function DirectoryExists(dir:string) : boolean;
var flags : integer;
begin
	flags := GetFileAttributes(pchar(dir));
	if (flags=-1) or ((flags and FILE_ATTRIBUTE_DIRECTORY)=0) then result := false
	else result := true;
end;

///////////////////////////////////////////////////////////////////////////////
//  Palette walker thingy.....bit overengineered, but looks cool!            //
///////////////////////////////////////////////////////////////////////////////
constructor pal_animator.create(nc,rf:integer; gamma_:double);
var lp1 : integer;
begin
	num_controls	:= nc;
	points				:= (236 div num_controls)*num_controls;
	pp_edge				:= points div num_controls;
	ran_factor		:= rf;
	gamma					:= gamma_;
	for lp1:=0 to num_controls-1 do begin
		controls[lp1].r := Random(254-2*ran_factor)+ran_factor+1;
		incs[lp1].r     := new_random_p; if random(2)=0 then incs[lp1].r:=-incs[lp1].r;
		controls[lp1].g := Random(254-2*ran_factor)+ran_factor+1;
		incs[lp1].g     := new_random_p; if random(2)=0 then incs[lp1].g:=-incs[lp1].g;
		controls[lp1].b := Random(254-2*ran_factor)+ran_factor+1;
		incs[lp1].b     := new_random_p; if random(2)=0 then incs[lp1].b:=-incs[lp1].b;
	end;
	for lp1:=0 to points-1 do RGB_nogamma[lp1].peFlags	:= PC_RESERVED;
	for lp1:=0 to points-1 do RGB_values[lp1].peFlags		:= PC_RESERVED;
	create_pseudo_gamma_lookups(gamma);
	update;
end;

function pal_animator.new_random_p : integer;
begin
	if ran_factor>1 then result := random(ran_factor)+1
	else result := 0;
end;

function pal_animator.new_random_m : integer;
begin
	if ran_factor>1 then result := -random(ran_factor)-1
	else result := 0;
end;

procedure pal_animator.update;
var lp1,lp2,inx,last : integer;
		tr,tg,tb         : double;
begin
	for lp1:=0 to num_controls-1 do begin
		controls[lp1].r := controls[lp1].r + incs[lp1].r;
		controls[lp1].g := controls[lp1].g + incs[lp1].g;
		controls[lp1].b := controls[lp1].b + incs[lp1].b;
		// add a little randomness when hitting edges
		if controls[lp1].r<=ran_factor            then incs[lp1].r := new_random_p
		else if controls[lp1].r>=(255-ran_factor) then incs[lp1].r := new_random_m;
		if controls[lp1].g<=ran_factor            then incs[lp1].g := new_random_p
		else if controls[lp1].g>=(255-ran_factor) then incs[lp1].g := new_random_m;
		if controls[lp1].b<=ran_factor            then incs[lp1].b := new_random_p
		else if controls[lp1].b>=(255-ran_factor) then incs[lp1].b := new_random_m;

		if (controls[lp1].r<0) then
			incs[lp1].r := new_random_p;
		if (controls[lp1].r>255) then
			incs[lp1].r := -new_random_p;
		if (controls[lp1].g<0) then
			incs[lp1].g := new_random_p;
		if (controls[lp1].g>255) then
			incs[lp1].g := -new_random_p;
		if (controls[lp1].b<0) then
			incs[lp1].b := new_random_p;
		if (controls[lp1].b>255) then
			incs[lp1].b := -new_random_p;
	end;
	last := num_controls-1;
	for lp1:=0 to num_controls-1 do begin
		inx         := last*pp_edge;
		RGB_nogamma[inx].peRed   := controls[last].r;
		RGB_nogamma[inx].peGreen := controls[last].g;
		RGB_nogamma[inx].peBlue  := controls[last].b;
		tr          := (controls[lp1].r - controls[last].r)/pp_edge;
		tg          := (controls[lp1].g - controls[last].g)/pp_edge;
		tb          := (controls[lp1].b - controls[last].b)/pp_edge;
		for lp2:=0 to pp_edge-1 do begin
			RGB_nogamma[inx+lp2].peRed   := controls[last].r + round(tr*lp2);
			RGB_nogamma[inx+lp2].peGreen := controls[last].g + round(tg*lp2);
			RGB_nogamma[inx+lp2].peBlue  := controls[last].b + round(tb*lp2);
		end;
		last := lp1;
	end;
	pseudo_gamma_correct;
end;

procedure pal_animator.create_pseudo_gamma_lookups(g:double);
var t1,t2 : double;
		lp1		: integer;
begin
	// create pseudo gamma lookup tables
	for lp1:= 0 to 255 do begin
		t1 := exp(g/2);
		t2 := exp(g*(lp1/255 -1/2));
		gamma_v[lp1] := round(255*(0.5 * ((t1+1)/(t1-1)) * ((t2-1)/(t2+1)) + 0.5));
	end;
end;

procedure pal_animator.pseudo_gamma_correct;
var lp1      : integer;
		tr,tg,tb : double;
begin
	for lp1:=0 to points-1 do begin
		RGB_values[lp1].peRed		:= gamma_v[RGB_nogamma[lp1].peRed];
		RGB_values[lp1].peGreen	:= gamma_v[RGB_nogamma[lp1].peGreen];
		RGB_values[lp1].peBlue	:= gamma_v[RGB_nogamma[lp1].peBlue];
	end;
end;

initialization
finalization
end.

