///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                      Assorted String/Stream utilities                     //
//                             John Biddiscombe                             //
//                           j.biddiscombe@rl.ac.uk                          //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////
unit Str_util;

interface

uses Classes,SysUtils;

procedure WriteString(dest:TMemoryStream; str:string);
function  read_line(source:TMemoryStream) : string;
function  BreakString(in_str:string; alist:TStringList) : TStringList;
function  a_word(in_str:string; inx:integer) : string;
function  BoolToStr(b:Boolean) : string;

implementation

procedure WriteString(dest:TMemoryStream; str:string);
var str2 : string;
begin
  str2 := str+#13#10; dest.write(str2[1],length(str2));
end;

function read_line(source:TMemoryStream) : string;
var achar  : char;
    OK     : boolean;
    buffer : array[0..4095] of char;
    count  : integer;
begin
  count := 0;
  OK := true;
  while OK do begin
    if source.read(achar,1)<1 then ok:=false;
    if ok then begin
      if achar=#13 then begin // check for #13#10 - Pascal style
        ok := false;
        if source.read(achar,1)<1 then ok:=false;
        if achar=#10 then begin end
        else source.position := source.position-1;
        achar := #0;
      end
      else if achar=#10 then begin // check for #10 - C++ (Unix) style
        ok := false;
        achar := #0;
      end;
      buffer[count] := achar;
      inc(count);
      if count>4095 then OK := false;
    end;
  end;
  buffer[count] := #0;
  result := StrPas(@buffer[0]);
end;

function a_word(in_str:string; inx:integer) : string;
var lp1,l  : integer;
    buffer : array[0..4095] of char;
    count  : integer;
begin
  l := length(in_str); lp1 := 1;
  repeat
    count := 0;
    while not (in_str[lp1] in [' ',#9,#13,#0]) do begin
      buffer[count] := in_str[lp1];
      inc(lp1); inc(count);
      if lp1>(l+1) then exit;
    end;
    dec(inx);  inc(lp1);
  until inx=0;
  buffer[count] := #0;
  result := StrPas(@buffer[0]);
end;

function BreakString(in_str:string; alist:TStringList) : TStringList;
var flag             : boolean;
    word,count,l,lp1 : integer;
    buffer           : array[0..4095] of char;
begin
  alist.Clear;
  result := alist;
  l := length(in_str); lp1 := 1;
  repeat
    count := 0; flag := false; word := 0;
    while not (in_str[lp1] in [#0,#32,#9,#13,#10]) do begin
      flag := true;
      buffer[count] := in_str[lp1];
      inc(lp1); inc(count);
      if lp1>(l+1) then exit;
    end;
    if flag then begin
      buffer[count] := #0;
      alist.Add(StrPas(@buffer[0]));
    end;
    inc(lp1);
  until lp1>(l+1);
end;

function BoolToStr(b:Boolean) : string;
begin
  if b then result := 'TRUE' else result := 'FALSE';
end;



end.
 