///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//              Zone Rings from Outer-Space 32 bit Delphi 2 version          //
//                         John Biddiscombe Sep 1997                        //
//                           j.biddiscombe@rl.ac.uk                          //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////
{
Thanks to
 Enrico Lodolo CIS 100275,1255 - Internet ldlc18k1@bo.nettuno.it
 For the Borland BWCC style RadioButtons, and Radiocheckboxes

 Original TBag (INI File) code by Mike Orriss (3K Computer Consultancy):
 Compuserve: 100570,121 (Modified by me)

 LZH compression
 * LZSS coded by Haruhiko OKUMURA
 * Adaptive Huffman Coding coded by Haruyasu YOSHIZAKI
 * Edited and translated to English by Kenji RIKITAKE
 * Translated from C to Turbo Pascal by Douglas Webb   2/18/91
 *    Update and bug correction of TP version 4/29/91 (Sorry!!)
 *    Added Delphi exception handling may 09 1996 Danny Heijl
 *                                                Danny.Heijl@cevi.be

 HiResTimer object
 Silicon Commander Games : http://www.silicmdr.com

}

program Zone_Rings_32;

uses
  { Borland }
  Windows,
  Forms,
  ThinkBox,
	Math_utils,
	PalUnit,
  Form_Main in 'Form_Main.pas' {Zonewindow},
  Form_Settings in 'Form_Settings.pas' {Settings_Form},
  Form_Load_Save in 'Form_Load_Save.pas' {LoadSave_Form},
  Zone_rings in 'Zone_rings.pas',
  Zone_settings in 'Zone_settings.pas',
  Screen_Utils in 'Screen_Utils.pas';

{$R *.RES}

{$R Zone_Rings_32_Cursors.res }

begin
	randomize;
	// read INI file
	ZOptions := Zone_Options.Create;
	if ZOptions.error_flag=[] then begin
		// Let's make sure we're in a 256 colour mode
		if not set_256_graphics_mode(ZOptions,false) then begin
			// The error flag will have been set
		end;
	end;
	//
	if not Set_Palette_Directory(ZOptions.Zone_Directory+'Palette\') then begin
		ZOptions.error_flag := ZOptions.error_flag + [palettes_not_found];
		ZOptions.error_string := ZOptions.error_string +
			'Zonerings couldn''t find palettes in ' + Palette_Dir + eol + eol;
	end;
	//
	Thinking(nil,'Initializing');
		screen.cursors[1] := LoadCursor(hInstance, pChar('MY_CURS_1'));
		screen.cursors[2] := LoadCursor(hInstance, pChar('MY_CURS_2'));
		Application.Initialize;
		Application.Title    := 'Zonerings from Outer-Space';
		Application.HelpFile := 'Zone_Rings_32_Help.hlp';
		setup_tables;
		Settings_Form  := TSettings_Form.Create(Application);
	stopped_thinking;

	// Now load the settings and stuff
	LoadSave_Form := TLoadSave_Form.Create(Application);
	// Create the mainwindow
	Application.CreateForm(TZonewindow, Zonewindow);
	// make sure no messages left on screen
  stopped_thinking;

  Application.Run;

	// put the screen mode back to what it was
  restore_original_screen_mode;
  // Cleanup
  ZOptions.Free;
end.
